// **************************************************
//  Driver for the Iglasses! Tracker
//
//
//	Author: Marcio Serolli Pinho 
//	pinho@inf.pucrs.br
// **************************************************

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include <windows.h>


#include "../../SerialLib.h"

void main(int argc, char *argv[])
{
	int byteRead;
    int i, trackerOK;
    short intRead;
    int msB, lsB;
	float data[3];

    // Open the serial port.... (port, speed, timeout)
	// Sometimes it is necessary to change the timeout

	if (OpenSerialPort(COM1,19200,500) == -1)
	{
        printf("Problemas na abertura da porta serial...\n");
        exit(1);
    }


    printf("Porta serial aberta.\n");

    // inicializa o tracker
	WriteSerialString("!M2,P,B,7,7\r");
	
	trackerOK = 1;
	do
	{
		// Envia um comando de leitura o tracker....
		WriteSerialOneByte('S');
		// L os dados da porta serial  
		byteRead = ReadSerialOneByte();

		if (byteRead == -1) // se houve erro na leitura
		{
			SerialClearBuffer();  // limpa a porta
			exit(1); // fim.
		}

		if (byteRead == 0) // Se nada foi lido...
		{
			SerialClearBuffer();  // limpa a porta
			printf("Esperando por um dado...\n");
			continue;
		}	
	
		// Os dados do tracker foram lidos com sucesso
		for (i=0; i<3; i++) 
		{
			msB = ReadSerialOneByte();
			lsB = ReadSerialOneByte();
			if (msB > 127) 
				intRead = (msB-255) * 255 + (lsB-255);
			else
				intRead = msB * 255 + lsB;

			// coleta os dados lidos para X, Y e Z        
			data[i] = (float) intRead * (180.0f/16384.0f);
		}

		// limpa a porta descartando dados lidos em excesso ...
		SerialClearBuffer();
		WriteSerialString("!R");

		//
		printf("Data: %20.6f%20.6f%20.6f\n", data[0], data[1], data[2]);

	} while(!kbhit());
	printf("Pressione ENTER para encerrar....");
	getchar();
}

/*
void main(int argc, char *argv[])
{
    int device;
    int baudrate = 9600;

	int byteRead;

    int i, trackerOK;
    short intRead;
    int msB, lsB;
	float data[3];


	OpenSerialPort(COM1);
    // Abre a porta serial....
	if (serial_open(&device, "COM1", 19200) == -1) 
	{
        printf("Problemas na abertura da porta serial...\n");
        exit(1);
    }

    printf("Porta serial aberta.\n");

    // inicializa o tracker
	serial_write_string(device, "!M2,P,B,7,7\r");
	
	trackerOK = 1;
	do
	{
		// Envia um comando de leitura o tracker....
		serial_write_byte(device, 'S');

		// L os dados da porta serial  
		byteRead = serial_read_byte(device);

		if (byteRead == -1) // se houve erro na leitura
		{
		   serial_flush_in(device);  // limpa a porta
		   exit(1); // fim.
		}

		if (byteRead == 0) // Se nada foi lido...
		{
			serial_flush_in(device); // limpa a porta
			printf("Esperando por um dado...\n");
			continue;
		}	
	
		// Os dados do tracker foram lidos com sucesso
		for (i=0; i<3; i++) 
		{
			msB = serial_read_byte(device);
			lsB = serial_read_byte(device);
			if (msB > 127) 
				intRead = (msB-255) * 255 + (lsB-255);
			else
				intRead = msB * 255 + lsB;

			// coleta os dados lidos para X, Y e Z        
			data[i] = (float) intRead * (180.0f/16384.0f);
		}

		// limpa a porta descartando dados lidos em excesso ...
		serial_flush_in(device); 

		//
		printf("Data: %20.6f%20.6f%20.6f\n", data[0], data[1], data[2]);

	} while(!kbhit());
	printf("Pressione ENTER para encerrar....");
	getchar();
}
*/